package cpcns.danganzhengli.mdb_wenjian.controller;

package .tmp;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.danganzhengli.mdb_wenjian.service.MDBWenJianService;
import cpcns.danganzhengli.mdb_wenjian.service.MdbService;
import cpcns.danganzhengli.mdb_wenjian.utils.ZipUtils;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import cpcns.wenjianshouji.util.FileUtil;
import java.io.File;
import java.nio.charset.Charset;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.SessionFactory;
import org.jfree.util.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;

@Controller
@RequestMapping({"/mdbImport"})
public class MdbContronller extends commonController {
  public static String FILE_UPLOAD_PATH = AppConfiguration.getConfigValue("OAUploadPath");
  
  public static String FILE_STORE_PATH = AppConfiguration.getConfigValue("OACaiJiPath");
  
  private SessionFactory sessionFactory;
  
  @Autowired
  private MDBWenJianService mdbWenJianService;
  
  @Autowired
  private MdbService mdbService;
  
  @RequestMapping({"/toimports.do"})
  public String toMdbImport() {
    return "danganzhengli/D_WenJian/importData";
  }
  
  @RequestMapping({"/importMessage.do"})
  public String importMessage(HttpServletRequest request, HttpServletResponse response, Model model) {
    String guiDangNianDu = getRequest().getParameter("guiDangNianDu");
    String baoGuanQiXian = getRequest().getParameter("baoGuanQiXian");
    String nd = getRequest().getParameter("nd");
    model.addAttribute("guiDangNianDu", guiDangNianDu);
    model.addAttribute("baoGuanQiXian", baoGuanQiXian);
    model.addAttribute("nd", nd);
    return "danganzhengli/D_WenJian/importMessage";
  }
  
  @RequestMapping({"/tolist.do"})
  public String query(Model model) {
    User user = getCurrentUser();
    String xtlx = AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING");
    String qzh = getFtpQuanZong();
    model.addAttribute("quanZongHao", qzh);
    return "danganzhengli/D_WenJian/MDB_WenJian_list";
  }
  
  @RequestMapping({"/getAll.do"})
  public String getAll(HttpServletRequest request, HttpServletResponse response, Model model) {
    try {
      Enumeration<?> rnames = getRequest().getParameterNames();
      JSONObject jsonObject = new JSONObject();
      for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
        String thisName = er.nextElement().toString();
        String thisValue = getRequest().getParameter(thisName);
        jsonObject.put(thisName, thisValue);
      } 
      User user = getCurrentUser();
      StringBuffer sqlWhere = new StringBuffer();
      Iterator<String> iterator = jsonObject.keys();
      StringBuffer sqlSearch = new StringBuffer();
      sqlSearch.append(" 1=1 ");
      while (iterator.hasNext()) {
        String key = iterator.next();
        String value = jsonObject.getString(key);
        if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !key.equals("nd") && 
          !"server".equals(key) && !"table".equals(key) && !"orderBy".equals(key) && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key)) {
          if (key.equals("guiDangNianDu")) {
            String nd = getRequest().getParameter("nd");
            if (StringUtils.isNotBlank(nd)) {
              sqlWhere.append(" and ").append(key).append(" ").append(nd).append("'").append(value).append("'");
              continue;
            } 
            sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'");
            continue;
          } 
          sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'");
        } 
      } 
      if (sqlWhere.length() > 0)
        sqlSearch.append(sqlWhere.toString()); 
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      model.addAttribute("page", page);
      model.addAttribute("rows", rows);
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      int start = (intPage - 1) * number;
      StringBuffer sql = new StringBuffer("select hangBiaoShi,xuHao,guanLianBiaoShi,yeShu,fenShu,biaoTi,dangHao,wenHao,miJi,chengWenRiQi,liJuanDanWeiMingCheng,liJuanDanWeiBiaoShi,guiDangBuMenMingCheng,guiDangBuMenBiaoShi,baoGuanQiXian,guiDangNianDu,guiDangLeiXing,youYuanWen,wenZhong,fenLeiMingCheng,zhuangTai,laiYuanMingCheng from MDB_WenJian where ");
      PagerVO pagevo = this.mdbWenJianService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "dengJiShiJian"), "MDB_WenJian");
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
      jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("XUHAO", "xuHao")
        .replaceAll("GUANLIANBIAOSHI", "guanLianBiaoShi").replaceAll("YESHU", "yeShu")
        .replaceAll("BIAOTI", "biaoTi").replaceAll("DANGHAO", "dangHao").replaceAll("WENHAO", "wenHao")
        .replaceAll("MIJI", "miJi").replaceAll("CHENGWENRIQI", "chengWenRiQi").replaceAll("LIJUANDANWEIMINGCHENG", "liJuanDanWeiMingCheng")
        .replaceAll("LIJUANDANWEIBIAOSHI", "liJuanDanWeiBiaoShi").replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng")
        .replaceAll("GUIDANGBUMENBIAOSHI", "guiDangBuMenBiaoShi").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("FENSHU", "fenShu")
        .replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("GUIDANGLEIXING", "guiDangLeiXing").replaceAll("YOUYUANWEN", "youYuanWen")
        .replaceAll("WENZHONG", "wenZhong").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng").replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("LAIYUANMINGCHENG", "laiYuanMingCheng");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/importDate.do"})
  public void importDate(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    try {
      boolean msg = false;
      String info = "";
      User user = getCurrentUser();
      String quanZongHao = getFtpQuanZong();
      rm = this.mdbService.importDate(request, response, user, quanZongHao);
    } catch (Exception exception) {}
    responseWriter(response, rm.toString());
  }
  
  public SessionFactory getSessionFactory() {
    return this.sessionFactory;
  }
  
  public void setSessionFactory(SessionFactory sessionFactory) {
    this.sessionFactory = sessionFactory;
  }
  
  @RequestMapping({"/remoteData.do"})
  public String remoteData(Model model, String quanZongHao) {
    model.addAttribute("quanZongHao", quanZongHao);
    return "danganzhengli/D_WenJian/html5Upload";
  }
  
  @RequestMapping({"/inprotZip.do"})
  @ResponseBody
  public void inprotZip(HttpServletRequest request, HttpServletResponse response) {
    Log.info("远程导入上传ZIP文件----------inprotZip.do");
    System.out.println("远程导入上传ZIP文件----------inprotZip.do");
    ResultMessage rm = new ResultMessage();
    try {
      String quanZongHao = getFtpQuanZong();
      HttpServletRequest request_ = ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
      User user = (User)request_.getSession().getAttribute("cpcns.sso.client.filter.user");
      if (user != null && StringUtils.isNotBlank(user.getQuanZongHao())) {
        System.out.println("user===============================" + user.getQuanZongHao());
        quanZongHao = user.getQuanZongHao();
      } 
      String genFileName = null;
      String zipFilePath = null;
      CommonsMultipartResolver multipartResolver = new CommonsMultipartResolver(request.getSession().getServletContext());
      if (multipartResolver.isMultipart(request)) {
        MultipartHttpServletRequest multiRequest = (MultipartHttpServletRequest)request;
        Iterator<String> iter = multiRequest.getFileNames();
        while (iter.hasNext()) {
          MultipartFile file = multiRequest.getFile(iter.next());
          if (file != null) {
            String myFileName = file.getOriginalFilename();
            if (myFileName.trim() != "") {
              genFileName = FileUtil.createRandomFileName(".zip");
              zipFilePath = String.valueOf(FILE_UPLOAD_PATH) + File.separator + quanZongHao + genFileName;
              Log.info("ZIPFILEPATH=============" + zipFilePath);
              System.out.println("ZIPFILEPATH=============" + zipFilePath);
              File localFile = new File(zipFilePath);
              file.transferTo(localFile);
            } 
          } 
        } 
      } 
      ZipFile zip = new ZipFile(new File(zipFilePath), Charset.forName("GBK"));
      Enumeration<? extends ZipEntry> entries = zip.entries();
      ZipEntry entry = entries.nextElement();
      String zipEntryName = entry.getName();
      System.out.println("zipEntryName=============" + zipEntryName);
      String deFileName = genFileName.substring(0, genFileName.indexOf(".zip"));
      String saveFileDir = String.valueOf(FILE_STORE_PATH) + File.separator + deFileName + zipEntryName;
      Log.info("zipFilePath======" + zipFilePath);
      System.out.println("zipFilePath======" + zipFilePath);
      Log.info("saveFileDir======" + saveFileDir);
      System.out.println("saveFileDir======" + saveFileDir);
      String mdb = ZipUtils.unZipFiles(zipFilePath, saveFileDir);
      System.out.println(mdb);
      boolean msg = false;
      String info = "";
      File mdbFile = new File(mdb);
      String path = mdb.substring(0, mdb.lastIndexOf("/"));
      String filePaths = String.valueOf(mdb.substring(0, path.lastIndexOf("/"))) + File.separator + "files";
      int count = 0;
      if (mdbFile.exists()) {
        count = this.mdbService.parsingMdbNew(filePaths, mdb);
        if (count > 0) {
          msg = true;
          info = "导入成功，本次导入条目总数是" + count + "条";
        } else {
          info = "导入失败";
        } 
      } 
      rm.setSuccess(msg);
      rm.setInfo(info);
    } catch (Exception e) {
      System.out.println(e.getMessage());
    } 
    responseWriter(response, rm.toString());
  }
}
